#!/opt/csw/bin/perl

use SOAP::Lite; # +trace =>qw(debug);
use XML::Parser;

my $req = SOAP::Lite
 ->proxy ('http://netmon.grnet.gr/pathfinder')
 ->uri ('http://netmon.grnet.gr/Pathfinder/PathfinderServer')
 ->outputxml (1)
 ->FindPath (
     SOAP::Data->value (
      SOAP::Data->name('source')->value('www.grnet.gr'),
      SOAP::Data->name('destination')->value(@ARGV[0]),
      SOAP::Data->name('doFullPath')->type('string')->value('0'),
      SOAP::Data->name('ingress')->value('195.251.25.201'),
      SOAP::Data->name('pathType')->type('string')->value('0')
     )
   );

$res="";
my $structure = new XML::Parser();
$structure ->setHandlers(Start => \&start, End => \&end, Char => \&cdata);
my $data = $structure->parse($req);

$currentTag = "";

sub start() {
my ($parser, $name, %attr) = @_;
$currentTag = lc($name);
}

sub end() {
my ($parser, $name) = @_;
$currentTag = lc($name);
$currentTag = "";
}

sub cdata() {
my ($parser, $data) = @_;
	if ($currentTag eq "nextdomainingress")
	{
		$res="$data";
		return($res);
	}
}

$filename = ">/home/quagga/".@ARGV[0].".out";
open(MYOUTFILE, $filename);
print MYOUTFILE $res; #write text-returning fcn
close(MYOUTFILE);

